package admin

import (
	. "../../../hotime"
	. "../../../hotime/common"
)

var ID = "3c5fc9732b8ddcb0a91b428976f2ce86"

// Project 管理端项目
var Project = Proj{
	//"user": UserCtr,
	"admin":          adminCtr,
	"category":       categoryCtr,
	"ctg_order_date": ctg_order_dateCtr,
	"order":          orderCtr,
	"org":            orgCtr,
	"role":           roleCtr,
	"user":           userCtr,
	"hotime": Ctr{
		"login": func(this *Context) {
			name := this.Req.FormValue("name")
			password := this.Req.FormValue("password")
			if name == "" || password == "" {
				this.Display(3, "参数不足")
				return
			}
			user := this.Db.Get("admin", "*", Map{"AND": Map{"name": name, "password": Md5(password)}})
			if user == nil {
				this.Display(5, "登录失败")
				return
			}
			this.Session("id", user.GetCeilInt("id"))
			this.Session("name", name)
			this.Display(0, "登录成功")
		},
		"logout": func(this *Context) {
			this.Session("id", nil)
			this.Session("name", nil)
			this.Display(0, "退出登录成功")
		},
		"info": func(that *Context) {
			re := that.Db.Get("admin", that.MakeCode.Info("admin"), Map{"id": that.Session("id").ToCeilInt()})

			if re == nil {
				that.Display(4, "找不到对应信息")
				return
			}

			for k, v := range re {

				column := that.MakeCode.TableColumns["admin"][k]
				if column == nil {
					continue
				}
				if (column["list"] == nil || column.GetBool("list")) && column.GetString("link") != "" {
					re[column.GetString("link")] = that.Db.Get(column.GetString("link"), column.GetString("value"), Map{"id": v})
				}
			}

			that.Display(0, re)
		},
	},
}
